﻿-- Author      : Rirean of Aging Gamer's on Dunemaul
-- Email	   : rizean@usa.net
-- Create Date : 5/25/2010 4:01:25 PM

AddonChecker = {}
local AC = AddonChecker;	-- Lazy short cut

-- Functions
-- Get our info
function AC.GetMyAddonVersions()
	if DBM then AC.DBMVer = DBM.Version else AC.DBMVer = "DNH" end
	if Dcr then AC.DecursiveVer = Dcr.version else AC.DecursiveVer = "DNH" end
	if GTFO then AC.GTFOVer = GTFO.Version else AC.GTFOVer = "DNH" end
	if Omen then AC.OmenVer = Omen.version else AC.OmenVer = "DNH" end 

	--HudMap does not have a version number so we go with a Yes/DNH (Does not have)
	if HudMap then AC.HudMapTF = "Yes" else AC.HudMapTF = "DNH" end;
end

--Send our Addon Info
--distribution type (dType) ("PARTY", "RAID", "GUILD", "BATTLEGROUND" or "WHISPER")
--prefix = "AddonChecker"
function AC.SendMyAddonVersions(dType, who)
	local msg;
	AC.GetMyAddonVersions();
	msg = ":DBM:" .. AC.DBMVer .. 
		  ":DCR:" .. AC.DecursiveVer .. 
		  ":GTF:" .. AC.GTFOVer .. 
		  ":OMN:" .. AC.OmenVer ..
		  ":HDM:" .. AC.HudMapTF ..
		  ":";

	SendAddonMessage("AddonChecker", msg, dType, who );
end

--/script AC.AddonMessageRecived(nil, "CHAT_MSG_ADDON", "AddonChecker", "iRequest", "WHISPER", "Rirean");
function AC.AddonMessageRecived(self, event, prefix, message, dType, sender)
	if not(event == "CHAT_MSG_ADDON" and prefix == "AddonChecker") then return end;
	if message == "iRequest" then 
		AC.SendMyAddonVersions(dType, sender);
		return;
	end
	
	-- If we got to here then we are reciving addon info.
	AC.ProcessMessage(message, dType, sender);
end

-- Process messages that have addon info in it
function AC.ProcessMessage(message, dType, sender)
	local raidID = "";
	local lDBM = "DNH";
	local lDCR = "DNH";
	local lGTF = "DNH";
	local lOMN = "DNH";
	local lHDM = "DNH";
	local temp;
	
	temp = string.match( string.match(message, ":DBM:[A-Za-z0-9.]+:"), "[A-Za-z0-9.]+");
	if temp ~= "" then lDBM = temp end;
	
	temp = string.match( string.match(message, ":DCR:[A-Za-z0-9.]+:"), "[A-Za-z0-9.]+");
	if temp ~= "" then lDCR = temp end;
	
	temp = string.match( string.match(message, ":GTF:[A-Za-z0-9.]+:"), "[A-Za-z0-9.]+");
	if temp ~= "" then lGTF = temp end
	
	temp = string.match( string.match(message, ":OMN:[A-Za-z0-9.]+:"), "[A-Za-z0-9.]+");
	if temp ~= "" then lOMN = temp end
	
	temp = string.match( string.match(message, ":HDM:[A-Za-z]+:"), "[A-Za-z]+");
	if temp ~= "" then lHDM =  temp end
	
	if dType == "WHISPER" then 
		raidID = sender;
		AC.ChatPrint(raidID .. " has: ");
		AC.ChatPrint("       DBM: " .. lDBM);
		AC.ChatPrint(" Decursive: " .. lDCR);
		AC.ChatPrint("      GTFO: " .. lGTF);
		AC.ChatPrint("      OMEN: " .. lOMN);
		AC.ChatPrint("    HudMap: " .. lHDM);
		return;
	elseif dType == "RAID" then
	
		local t
		for i = 1, 10, 1 do
			if sender ==  GetUnitName("raid"..i) then 
				raidID = "raid"..i;
				t = i;
			end
		end
		
		getglobal("FontStringNRaid"..t):SetText(sender);
		getglobal("FontStringCRaid"..t):SetText(UnitClass(raidID));
		getglobal("FontStringDRaid"..t):SetText(lDBM);
		getglobal("FontStringGRaid"..t):SetText(lGTF);
		getglobal("FontStringHRaid"..t):SetText(lHDM);
		getglobal("FontStringORaid"..t):SetText(lOMN);
	
	end
end

--Chat print function
function AC.ChatPrint(str)
	if str == nil then str = "Error: Nothing to print!" end;
	DEFAULT_CHAT_FRAME:AddMessage("[AddonChecker] "..str, 0.25, 1.0, 0.25);
end

-- On Load
function AC.OnLoad()
	AC.Version = "0.1.0a"		-- Frist Alpha Release
	AC.ChatPrint(AC.Version)

	-- Init
	for i = 1, 10, 1 do
   			getglobal("FontStringNRaid"..i):SetText("");
			getglobal("FontStringCRaid"..i):SetText("");
			getglobal("FontStringDRaid"..i):SetText("");
			getglobal("FontStringGRaid"..i):SetText("");
			getglobal("FontStringHRaid"..i):SetText("");
			getglobal("FontStringORaid"..i):SetText("");
	end
end

-- Event Handler
local function eventHandler(self, event, arg1, arg2, arg3, arg4)
	if event == "CHAT_MSG_ADDON" and arg1 == "AddonChecker" then AC.AddonMessageRecived(self, event, arg1, arg2, arg3, arg4) end;
	if event == "ADDON_LOADED" then AC.OnLoad() end;
end

-- Event Registery
local eventFrame = CreateFrame("FRAME", "ACEVENTFRAME");
eventFrame:RegisterEvent("CHAT_MSG_ADDON");
eventFrame:RegisterEvent("ADDON_LOADED");
eventFrame:SetScript("OnEvent", eventHandler);

-- Slash Command Handler
SLASH_ADDONCHECKER1, SLASH_ADDONCHECKER2 = '/ac', '/addonchecker';
local function handler(msg, editbox)
	if msg == "raidcheck" or msg == "rc" then
		SendAddonMessage("AddonChecker", "iRequest", "RAID");
		AddonCheckerFrame:Show();
		return;
	elseif msg == "help" or msg == "?" or msg == "" then
		AC.ChatPrint("raidcheck or rc to do a raidwide addon check")
		AC.ChatPrint("[name] of a person to request their addon info if they are running Addon Checker")
		AC.ChatPrint("help or ? to get this listing")
		return;
	else
		SendAddonMessage("AddonChecker", "iRequest", "WHISPER", msg);
		return;
	end		 
end
SlashCmdList["ADDONCHECKER"] = handler;



--newFrame = CreateFrame("frameType"[, "frameName"[, parentFrame[, "inheritsFrame"]]]);